public class Graphe{
    private char  atome;
    private Graphe[] liaisons;
    private int couleur;

    public Graphe(char c){
	switch (c) {
	case 'C' :
	case 'c' : {
	    atome = 'C';
	    liaisons = new Graphe[4];
	    break;
	}
	case 'O' :
	case 'o' : {
	    atome = '0';
	    liaisons = new Graphe[2];
	    break;
	}
	case 'H' :
	case 'h' : {
	    atome = 'H';
	    liaisons = new Graphe[1];
	    break;
	}
	default : {
	    new Exception("Atome inconnu");
	}
	}
	couleur = 0;
    }
    public final int      getAtome()       {return atome;}
    public final int      getCouleur()     {return couleur;}
    public final int      getNbLiaisons()  {return liaisons.length;}
    public final Graphe[] getLiaisons()    {return liaisons;}
    public final void     setCouleur(int c){couleur = c;}
    public final boolean  isLibre()        {return premierLibre() < liaisons.length;} 
    public final boolean  isRadical()      {return premierLibre() >= (liaisons.length -1);} 
    
    private int premierLibre(){
	int i = 0;
	while (i<liaisons.length && liaisons[i] != null){i++;}
	return i;
    }
    
    private void lier(int i, Graphe g){
	liaisons[i] = g;
    }
    
    public static final boolean lier(Graphe g1, Graphe g2){
	int l1 = g1.premierLibre();
	if (l1 < g1.getNbLiaisons()){
	    int l2 = g2.premierLibre();
	    if (l2 < g2.getNbLiaisons()){
		g1.lier(l1, g2);
		g2.lier(l2, g1);
		return true;
	    }
	    else
		return false;
	}
	else
	    return false;
    }
    
    public final void parcours(StrategieParcours sp){
	couleur = 1;
	sp.visiterNoeudEntree(this);
	for (int i=0; i<liaisons.length; i++)
	    if (liaisons[i]!=null && liaisons[i].getCouleur()==0)
		liaisons[i].parcours(sp);
	sp.visiterNoeudSortie(this);
	couleur = 2;
    }
}
